﻿using System;
using System.Collections.Generic;
using UnityEngine;

namespace CarMod
{
	public class CarMod : MonoBehaviour
	{
		public static void Main()
		{

		ModAPI.Register(
	 new Modification()
	        {
		        OriginalItem = ModAPI.FindSpawnable("Tank"),
		        NameOverride = "M1A2 Abrams",
		        NameToOrderByOverride = "!",
		        DescriptionOverride = "M1A2 Abrams main battle tank is manufactured by General Dynamics Land Systems. The first M1 tank was produced in 1978, and the M1A2 in 1986.",
		        CategoryOverride = ModAPI.FindCategory("Vehicles"),
		        ThumbnailOverride = ModAPI.LoadSprite("Textures/Thumb.png"),
		        AfterSpawn = (Instance) =>
		        {
			    //Main
                    Destroy(Instance.GetComponentInChildren<RandomCarTextureBehaviour>());
                    var TankHead = Instance.transform.Find("Head");
                    var TankBody = Instance.transform.Find("Body"); 
                    var TankBarrel = Instance.transform.Find("Barrel"); 
                    var TankGasTank = Instance.transform.Find("Gas tank"); 
                    var TankEngine = Instance.transform.Find("Engine"); 

                    var TankSettings = TankBody.GetComponent<CarBehaviour>();
                    TankSettings.MotorSpeed = -500f;
                    TankSettings.WaterProof = false;
                    
                    var BarrelSettings = TankBarrel.GetComponent<TankBarrelBehaviour>();
                    BarrelSettings.RecoilIntensity = 25f; //15
                    BarrelSettings.barrelPosition = new Vector2(3.67f, 0f);
                    //BarrelSettings.barrelPosition = new Vector2(3.67f, 0f);
                    BarrelSettings.barrelDirection = new Vector2(1, 0);

                //DestroyColliders
                    BoxCollider2D[] boxColliders = TankHead.GetComponents<BoxCollider2D>();
                    GameObject.Destroy(boxColliders[0]);
                    GameObject.Destroy(boxColliders[1]);
                    GameObject.Destroy(boxColliders[2]);

                    BoxCollider2D[] boxColliders2 = TankBody.GetComponents<BoxCollider2D>();
                    GameObject.Destroy(boxColliders2[0]);
                    GameObject.Destroy(boxColliders2[1]);
                    GameObject.Destroy(boxColliders2[2]);
                    GameObject.Destroy(boxColliders2[3]);
                    GameObject.Destroy(boxColliders2[4]);

                    BoxCollider2D[] boxColliders3 = TankBarrel.GetComponents<BoxCollider2D>();
                    GameObject.Destroy(boxColliders3[0]);

                //Tank Head
			        TankHead.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                    {
                        ModAPI.LoadSprite("Textures/Head.png"),
                    };
                    PolygonCollider2D TankHeadColl = TankHead.GetComponent<PolygonCollider2D>();
                    TankHeadColl.pathCount = 1;
                    TankHeadColl.SetPath(0, new Vector2[]
                    {
                        new Vector2(1.6314857f,0.184812218f),
                        new Vector2(1.52837765f,0.278122693f),
                        new Vector2(0.441590995f,0.410492361f),
                        new Vector2(0.431270599f,0.553485155f),
                        new Vector2(-0.43660453f,0.55257839f),
                        new Vector2(-0.578489304f,0.379149199f),
                        new Vector2(-0.757416606f,0.37690264f),
                        new Vector2(-0.853400052f,0.263757586f),
                        new Vector2(-2.61639595f,0.265810847f),
                        new Vector2(-2.61716962f,0.318027824f),
                        new Vector2(-2.77894449f,0.319069624f),
                        new Vector2(-2.98050332f,0.0641085505f),
                        new Vector2(-3.14709687f,0.0608592033f),
                        new Vector2(-3.23824358f,-0.134591088f),
                        new Vector2(-3.46509767f,-0.137840196f),
                        new Vector2(-3.46211982f,-0.364678144f),
                        new Vector2(-2.99959159f,-0.465325445f),
                        new Vector2(-2.61677456f,-0.461370319f),
                        new Vector2(-2.53225327f,-0.407977879f),
                        new Vector2(-2.28820467f,-0.660381675f),
                        new Vector2(-1.57422578f,-0.835526586f),
                        new Vector2(3.08029175f,-0.825316548f),
                        new Vector2(3.30741239f,-0.471253693f),
                        new Vector2(3.29403281f,-0.426766813f),
                        new Vector2(2.94575667f,0.0781132281f)
                    });
                //Body	
					TankBody.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                    {
                        ModAPI.LoadSprite("Textures/Body.png"),	
                    };
                    PolygonCollider2D TankBodydColl = TankBody.gameObject.AddComponent<PolygonCollider2D>();
                    TankBodydColl.pathCount = 1;
                    TankBodydColl.SetPath(0, new Vector2[]
                    {
                        new Vector2(5.10183191f,0.1574523f),
                        new Vector2(4.86962461f,0.221892983f),
                        new Vector2(3.8361783f,0.299717456f),
                        new Vector2(3.82823563f,0.416426361f),
                        new Vector2(3.59228563f,0.412172019f),
                        new Vector2(3.50473976f,0.307014793f),
                        new Vector2(3.00265193f,0.303972274f),
                        new Vector2(3.00087404f,0.463228405f),
                        new Vector2(2.72420216f,0.46626693f),
                        new Vector2(2.56633377f,0.361793041f),
                        new Vector2(1.91712189f,0.443818569f),
                        new Vector2(2.82774639f,0.595663786f),
                        new Vector2(2.82237482f,0.657660365f),
                        new Vector2(1.6266613f,0.673429012f),
                        new Vector2(-1.47565532f,0.672020793f),
                        new Vector2(-1.48630655f,0.466950178f),
                        new Vector2(-2.74544144f,0.724278927f),
                        new Vector2(-2.77404761f,0.724936962f),
                        new Vector2(-5.0621829f,0.734445095f),
                        new Vector2(-5.14096308f,0.664267242f),
                        new Vector2(-5.11322546f,-0.120576277f),
                        new Vector2(-4.6991663f,-0.124555603f),
                        new Vector2(-3.80587363f,-0.0712018758f),
                        new Vector2(-3.65903807f,-0.216941357f),
                        new Vector2(-3.59791589f,-0.570784509f),
                        new Vector2(4.47447014f,-0.581769407f),
                        new Vector2(4.77418804f,-0.355621606f),
                        new Vector2(5.1103425f,0.0486336984f)
                    });
                //Barrel							
			        TankBarrel.gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                	{
                        ModAPI.LoadSprite("Textures/Barrel.png"),
                    };
                    PolygonCollider2D TankBarrelColl = TankBarrel.gameObject.AddComponent<PolygonCollider2D>();
                    TankBarrelColl.pathCount = 1;
                    TankBarrelColl.SetPath(0, new Vector2[]
                    {
                        new Vector2(0.483041465f,0.0865726471f),
                        new Vector2(0.285987735f,0.190511644f),
                        new Vector2(-0.0747375488f,0.319386482f),
                        new Vector2(-0.932544231f,0.318984926f),
                        new Vector2(-1.20031166f,0.0987696648f),
                        new Vector2(-2.22155762f,0.262416363f),
                        new Vector2(-3.63444233f,0.250101388f),
                        new Vector2(-3.6256361f,-0.34168601f),
                        new Vector2(-2.97275352f,-0.338789463f),
                        new Vector2(-1.19107056f,-0.224064827f),
                        new Vector2(-0.969928741f,-0.328559875f),
                        new Vector2(0.318187714f,-0.324342728f),
                        new Vector2(0.476337433f,-0.227710724f),
                        new Vector2(3.63898563f,-0.234704733f),
                        new Vector2(3.63378048f,0.0842420906f),
                        new Vector2(3.45440269f,0.172355294f)
                    });				
                //Gas Tank
			        Instance.transform.Find("Gas tank").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                	{
                        ModAPI.LoadSprite("Textures/Gastank.png"),
                    };	
                //Engine
			        Instance.transform.Find("Engine").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                	{
                        ModAPI.LoadSprite("Textures/Engine.png"),
                    };	
			    //Wheels
			            Instance.transform.Find("Wheel").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel1.png"),
                                };

			            Instance.transform.Find("Wheel (1)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
               	                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (2)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (3)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (4)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };
			
		                Instance.transform.Find("Wheel (5)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (6)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                                {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                                };

			            Instance.transform.Find("Wheel (7)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                                    ModAPI.LoadSprite("Textures/Wheel0.png"),
                        };

			            Instance.transform.Find("Wheel (8)").gameObject.AddComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                                    ModAPI.LoadSprite("Textures/Wheel1.png"),
                        };
                //Other
                    Instance.AddComponent<NoChildrenCollide>();
                    NoCollide noCollide = Instance.AddComponent<NoCollide>();
                    noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
                    noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
			        }
		        }
	    );

		//Tank Mounts
		ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "A Tankmount for M1A2 - 1",
                    NameToOrderByOverride = "A Tankmount for M1A2 - 1",
                    DescriptionOverride = "This is a Gun Mount for the M1A2.",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Mount1Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Mount1.png", 1f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 13f;
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.FixColliders();
                    }
                }
			);

		ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "A Tankmount for M1A2 - 2",
                    NameToOrderByOverride = "A Tankmount for M1A2 - 2",
                    DescriptionOverride = "This is a Gun Mount for the Leopard.",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Mount2Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Mount2.png", 1f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 13f;
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.FixColliders();
                    }
                }
			);

        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "A Tankmount for M1A2 - 3",
                    NameToOrderByOverride = "A Tankmount for M1A2 - 3",
                    DescriptionOverride = "This is a Gun Mount for the Leopard.",
                    CategoryOverride = ModAPI.FindCategory("Misc."),
                    ThumbnailOverride = ModAPI.LoadSprite("Textures/Mount3Thumb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Mount3.png", 1f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 13f;
                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.FixColliders();
                    }
                }
			);    

		}
	}
	     
}

